EnableExplicit

Global PBEx_MSSQL

CompilerIf #PB_Compiler_Processor = #PB_Processor_x86
  PBEx_MSSQL = OpenLibrary(#PB_Any, "PB.Ex_MSSQL_x86.dll")
CompilerElseIf #PB_Compiler_Processor = #PB_Processor_x64
  PBEx_MSSQL = OpenLibrary(#PB_Any, "PB.Ex_MSSQL_x64.dll")
CompilerEndIf

If PBEx_MSSQL
  Prototype ExecuteSQLQuery(ConnectionString.p-Unicode, SQL.p-Unicode, Timeout, Output, ErrorOutput)
  Global ExecuteSQLQuery.ExecuteSQLQuery = GetFunction(PBEx_MSSQL, "ExecuteSQLQuery")
  Prototype GetDatabaseBlobEx(ConnectionString.p-Unicode, Table.p-Unicode, Column.p-Unicode, Where.p-Unicode, Memory, MemoryLength, ErrorOutput)
  Global GetDatabaseBlobEx.GetDatabaseBlobEx = GetFunction(PBEx_MSSQL, "GetDatabaseBlobEx")
  Prototype SetDatabaseBlobEx(ConnectionString.p-Unicode, Table.p-Unicode, Column.p-Unicode, Where.p-Unicode, Memory, MemoryLength, ErrorOutput)
  Global SetDatabaseBlobEx.SetDatabaseBlobEx = GetFunction(PBEx_MSSQL, "SetDatabaseBlobEx")
  
  Define Output$ = Space(1000000)
  Define ErrorOutput$ = Space(1024)
  
  ;-Please change this
  Define Server$ = "YourServer"
  Define Database$ = "YourDatabase"
  Define User$ = "YourUsername"
  Define Password$ = "YourPassword"
  
  ;====================================================================================================
  
  ;-Get records from table
  If ExecuteSQLQuery("Server=" + Server$ + ";Database=" + Database$ + ";User Id=" + User$ + ";Password=" + Password$ + ";", "SELECT * FROM MyTable", 0, @Output$, @ErrorOutput$)
    ParseXML(1, Output$)
    FormatXML(1, #PB_XML_WindowsNewline | #PB_XML_ReFormat | #PB_XML_ReIndent)
    Debug ComposeXML(1)
  Else
    Debug "Error: " + ErrorOutput$
  EndIf
  
  ;====================================================================================================
  
  ;-Create new record in table
;   If ExecuteSQLQuery("Server=" + Server$ + ";Database=" + Database$ + ";User Id=" + User$ + ";Password=" + Password$ + ";", "INSERT INTO MyTable (Prename, Lastname, Age, IsEnabled) VALUES ('Max', 'Mustermann', 18, 1) ", 0, @Output$, @ErrorOutput$)
;     Debug "Successful"
;   Else
;     Debug "Error: " + ErrorOutput$
;   EndIf
  
  ;====================================================================================================
  
  ;-Import file to database
  ;1. Load the file into memory.
;   Define length
;   Define *MemoryID
;   Define bytes
;   If ReadFile(1, "YourImage.png")
;     length = Lof(1)
;     *MemoryID = AllocateMemory(length)
;     If *MemoryID
;       bytes = ReadData(1, *MemoryID, length) 
;     EndIf
;     CloseFile(1)
;   EndIf
;   
;   ;2. Send the memory to database.
;   If SetDatabaseBlobEx("Server=" + Server$ + ";Database=" + Database$ + ";User Id=" + User$ + ";Password=" + Password$ + ";", "MyTable", "BinText", "ID = 2", *MemoryID, bytes, @ErrorOutput$)
;     Debug "Successful"
;   Else
;     Debug "Error: " + ErrorOutput$
;   EndIf
  
  ;====================================================================================================
  
  ;-Export file from database
;   ;1. Determine the size of the file to be created.
;   Define FileLength
;   FileLength = GetDatabaseBlobEx("Server=" + Server$ + ";Database=" + Database$ + ";User Id=" + User$ + ";Password=" + Password$ + ";", "MyTable", "BinText", "ID = 2", 0, 0, @ErrorOutput$)
;   If FileLength = 0
;     Debug "Error: " + ErrorOutput$
;   EndIf
;   
;   ;2. Import and save file.
;   Define *MemoryID2 = AllocateMemory(FileLength)
;   If GetDatabaseBlobEx("Server=" + Server$ + ";Database=" + Database$ + ";User Id=" + User$ + ";Password=" + Password$ + ";", "MyTable", "BinText", "ID = 2", *MemoryID2, FileLength, @ErrorOutput$)
;     If CreateFile(1, "YourImageFromDB.png")
;       WriteData(1, *MemoryID2, FileLength)
;       CloseFile(1)
;     EndIf
;     Debug "Successful"
;   Else
;     Debug "Error: " + ErrorOutput$
;   EndIf
  
  
  
  CloseLibrary(PBEx_MSSQL)
EndIf
